/*
 Navicat Premium Data Transfer

 Source Server         : TOPSUN开发环境外网连接
 Source Server Type    : Oracle
 Source Server Version : 110200
 Source Host           : 171.217.93.4:52521
 Source Schema         : AVIC_SYS

 Target Server Type    : Oracle
 Target Server Version : 110200
 File Encoding         : 65001

 Date: 13/03/2020 17:25:38
*/


-- ----------------------------
-- Table structure for TBPM_OTHER_SYSTEM_CONFIG
-- WebService 接口权限配置表
-- ----------------------------
DROP TABLE TBPM_OTHER_SYSTEM_CONFIG;
CREATE TABLE TBPM_OTHER_SYSTEM_CONFIG (
  ID VARCHAR2(32 BYTE) NOT NULL primary key,
  SYSTEM_ID VARCHAR2(32 BYTE) ,
  CODE VARCHAR2(64 BYTE) ,
  NAME VARCHAR2(128 BYTE) ,
  SYSTEM_SERVICE_CATEGORY VARCHAR2(32 BYTE) ,
  SYSTEM_SERVICE_NAME VARCHAR2(128 BYTE) ,
  REMARK VARCHAR2(1024 BYTE) ,
  VERSION NUMBER,
  STATUS NUMBER,
  IS_ENABLE_RULE NUMBER,
  RULE_CODE VARCHAR2(64 BYTE),
  RULE_NAME VARCHAR2(128 BYTE)
);
comment on table TBPM_OTHER_SYSTEM_CONFIG is 'WebService 接口权限配置表';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.ID IS '主键';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.SYSTEM_ID IS '第三方系统ID';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.CODE IS '第三方系统编码';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.NAME IS '第三方系统名称';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.SYSTEM_SERVICE_CATEGORY IS '第三方系统访问 Service 类别(接口类型配置表CODE)';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.SYSTEM_SERVICE_NAME IS '第三方系统访问 Service 类别名称(接口类型配置表NAME)';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.IS_ENABLE_RULE IS '是否启用规则验证 0:否;1:是';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.RULE_CODE IS '规则编号';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.RULE_NAME IS '规则名称';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.REMARK IS '第三方系统接口配置备注';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.VERSION IS '系统版本号';
COMMENT ON COLUMN TBPM_OTHER_SYSTEM_CONFIG.STATUS IS '状态';
-- ----------------------------
-- Table structure for TBPM_WEB_SERVICE_CONFIG_TYPE
-- WebService 接口类型配置表
-- ----------------------------
DROP TABLE TBPM_WEB_SERVICE_CONFIG_TYPE;
CREATE TABLE TBPM_WEB_SERVICE_CONFIG_TYPE (
  ID VARCHAR2(64 BYTE) NOT NULL primary key,
  VERSION NUMBER ,
  SYSTEM_SERVICE_CODE VARCHAR2(64 BYTE) ,
  SERVICE_METHOD VARCHAR2(64 BYTE) ,
  CODE VARCHAR2(64 BYTE) ,
  NAME VARCHAR2(128 BYTE) ,
  STATUS NUMBER ,
  SERVICE_PARAMTERS VARCHAR2(64 BYTE) ,
  SERVICE_PARAM_TYPES VARCHAR2(64 BYTE),
  IS_ENABLE_RULE NUMBER,
  RULE_CODE VARCHAR2(64 BYTE),
  RULE_NAME VARCHAR2(128 BYTE)
);
comment on table TBPM_WEB_SERVICE_CONFIG_TYPE is 'WebService 接口类型配置表';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.ID IS '主键';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.VERSION IS '版本号';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.SYSTEM_SERVICE_CODE IS '第三方系统访问 Service 对象名称';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.SERVICE_METHOD IS '接口方法名称';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.CODE IS '第三方系统编码';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.NAME IS '第三方系统名称';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.STATUS IS '1 启用 0 禁用';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.SERVICE_PARAMTERS IS '接口参数名称';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.SERVICE_PARAM_TYPES IS '接口参数类型';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.IS_ENABLE_RULE IS '是否启用规则验证 0:否;1:是';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.RULE_CODE IS '规则编号';
COMMENT ON COLUMN TBPM_WEB_SERVICE_CONFIG_TYPE.RULE_NAME IS '规则名称';
-- WebService规则配置表
DROP TABLE TBPM_WEB_SERVICE_RULE;
create table TBPM_WEB_SERVICE_RULE
(
    ID            VARCHAR2(64) not null
        primary key,
    VERSION       NUMBER,
    CODE          VARCHAR2(64),
    NAME          VARCHAR2(128),
    RULES         CLOB,
    REMARK        VARCHAR2(2048),
    STATUS        NUMBER,
    RULES_CONTENT CLOB
);
comment on table TBPM_WEB_SERVICE_RULE is 'WebService 接口规则配置表';
comment on column TBPM_WEB_SERVICE_RULE.ID is '主键';
comment on column TBPM_WEB_SERVICE_RULE.VERSION is '版本号';
comment on column TBPM_WEB_SERVICE_RULE.CODE is '规则编码';
comment on column TBPM_WEB_SERVICE_RULE.NAME is '规则名称';
comment on column TBPM_WEB_SERVICE_RULE.RULES is '规则内容';
comment on column TBPM_WEB_SERVICE_RULE.REMARK is '备注';
comment on column TBPM_WEB_SERVICE_RULE.STATUS is '状态';
comment on column TBPM_WEB_SERVICE_RULE.RULES_CONTENT is '规则内容HTML';